#include <iostream>

int negateInt(int in) {
  in = ~in + 1;
  return in;
}

int negateIntAsm(int in) {
  asm("xor $0xffffffff, %0;"
      "add $0x1, %0;"
      : "=r" (in) // output
      : "0" (in) // input
      : // clobbered registers
      );
  return in;
}

int absInt(int in) {
  if (in < 0)
    in = ~in + 1;

  return in;
}

int absIntAsmClang(int in) {
  asm("cmpl $0x0, %0;"
      "jge nonneg;"
      "xor $0xffffffff, %0;"
      "add $0x1, %0;"
      "nonneg:;"
      : "=r" (in) // output
      : "0" (in) // input
      : // clobbered registers
      );
  return in;
}

int absInt2(int in) {
  int sign = in >> 31;
  if (sign == 1)
    in = ~in + 1;

  return in;
}

int absInt2Clang(int in) {
  asm ("mov %0, %%eax;"
       "shr $0x1f, %%eax;"
       "cmpl $0x1, %%eax;"
       "jne nonneg2;"
       "xor $0xffffffff, %1;"
       "add $0x1, %1;"
       "nonneg2:;"
       : "=r" (in) // output
       : "r" (in) // input
       : "eax" // clobbered
       );
  return in;
}


int main() {
  if (negateInt(-5) != negateIntAsm(-5))
    std::cerr << "Failed\n";
  else
    std::cerr << "Success\n";
  return 0;
}
